package com.gic.haoban.manage.api.service.hm;

import java.util.List;

import com.gic.api.base.commons.BasePageInfo;
import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.haoban.manage.api.dto.hm.HmLinkDTO;
import com.gic.haoban.manage.api.dto.hm.HmLinkWxaDTO;
import com.gic.haoban.manage.api.dto.qdto.hm.HmLinkSearchQDTO;

/**
 * 
* @ClassName: HmLinkApiService
* @Description: 活码链接
* @author xugh
* @date 2022年7月1日 下午2:24:40
*
 */
public interface HmLinkApiService {

    public ServiceResponse<HmLinkDTO> getByLinkId(String wxEnterpriseId, String enterprieId, Long linkId);

    /**
     * 
    * @Title: listForSms
    * @Description: 营销短信-查询专用链接
    * @author xugh
    * @param wxEnterpriseId
    * @param enterprieId
    * @param linkName
    * @return
    * @throws
     */
    public ServiceResponse<List<HmLinkDTO>> listForSms(String wxEnterpriseId, String enterprieId, String linkName);

    public ServiceResponse<Page<HmLinkDTO>> listPage(HmLinkSearchQDTO qdto, BasePageInfo basePageInfo);

    public ServiceResponse<HmLinkDTO> save(HmLinkDTO dto);

    /**
     * 
    * @Title: getLinkHm
    * @Description: 小程序获取展示活码
    * @author xugh
    * @return
    * @throws
     */
    public ServiceResponse<HmLinkWxaDTO> getLinkHmFromWxa(String enterpriseId, String storeId, String clerkId,
            String linkId, String mixPhone, String unionid);
}
