package com.gic.haoban.manage.service.service.hm.impl;

import com.gic.api.base.commons.Page;
import com.gic.commons.util.EntityUtil;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.manage.api.dto.qdto.hm.HmQrcodeListQDTO;
import com.gic.haoban.manage.api.dto.qdto.hm.HmQrcodeQDTO;
import com.gic.haoban.manage.service.dao.mapper.hm.TabHaobanHmQrcodeMapper;
import com.gic.haoban.manage.service.entity.hm.TabHaobanHmQrcode;
import com.gic.haoban.manage.service.pojo.bo.hm.HmQrcodeBO;
import com.gic.haoban.manage.service.service.hm.TabHaobanHmQrcodeService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * 活码(TabHaobanHmQrcode)表服务实现类
 *
 * @author mozhu
 * @since 2022-07-04 15:42:20
 */
@Service("tabHaobanHmQrcodeService")
public class TabHaobanHmQrcodeServiceImpl implements TabHaobanHmQrcodeService {

    @Autowired
    private TabHaobanHmQrcodeMapper tabHaobanHmQrcodeMapper;

    @Override
    public HmQrcodeBO queryById(Long hmId) {
        return EntityUtil.changeEntity(HmQrcodeBO.class, this.tabHaobanHmQrcodeMapper.queryById(hmId));
    }

    @Override
    public Page<HmQrcodeBO> queryByPage(HmQrcodeListQDTO hmQrcodeListQDTO) {
        PageHelper.startPage(hmQrcodeListQDTO.getPageNum(), hmQrcodeListQDTO.getPageSize());
        List<TabHaobanHmQrcode> tabHaobanHmQrcodes = tabHaobanHmQrcodeMapper.queryListByPage(hmQrcodeListQDTO);
        return PageUtil.changePageHelperToCurrentPage(new PageInfo<>(tabHaobanHmQrcodes), HmQrcodeBO.class);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insert(HmQrcodeQDTO hmQrcodeQDTO) {
        hmQrcodeQDTO.setCreateTime(new Date());
        hmQrcodeQDTO.setUpdateTime(new Date());
        return this.tabHaobanHmQrcodeMapper.insert(EntityUtil.changeEntity(TabHaobanHmQrcode.class, hmQrcodeQDTO));
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int update(HmQrcodeQDTO hmQrcodeQDTO) {
        hmQrcodeQDTO.setUpdateTime(new Date());
        return this.tabHaobanHmQrcodeMapper.update(EntityUtil.changeEntity(TabHaobanHmQrcode.class, hmQrcodeQDTO));
    }

    /**
     * 通过主键删除数据
     *
     * @param hmId 主键
     * @return 是否成功
     */
    @Override
    public boolean deleteById(Long hmId) {
        return this.tabHaobanHmQrcodeMapper.deleteById(hmId) > 0;
    }
}
